<?php

class apiCall {

	private $_name, $_get, $_post, $_execResult, $_execResultString;

	function __construct ($get = null, $post = null, $files = null) {
		$this->_name = 'ApiUserSetPassword';
		$this->_get = $get;
		$this->_post = $post;
		$this->_execResult = true;
		$this->_execResultString = 'success';
	}

	function execute () {

		$apiUsers = file_get_contents('/usr/conf/apiusers.conf');

		// check if user proviosioning exists
		if (!strstr($apiUsers, 'provisioning:')) {
			$this->_execResultString = 'error:user_does_not_exist';
			$this->_execResult = false;
			return($this->_execResult);
		}

		// check if user proviosioning is enabled
		if (strstr($apiUsers, '# provisioning:')) {
			$this->_execResultString = 'error:user_is_disabled';
			$this->_execResult = false;
			return($this->_execResult);
		}

		// check if password is valid
		if (!isset($this->_get['NewPassword']) || empty($this->_get['NewPassword'])) {
			$this->_execResultString = 'error:invalid_or_no_password_supplied';
			$this->_execResult = false;
			return($this->_execResult);
		}

		// preserve line of user admin
		preg_match('/(admin:[0-9a-zA-Z]*)/', $apiUsers, $matches);
		$adminLine = $matches[1];
		unset($matches);

		// create new password for user provisioning
		$newPasswordEnc = crypt($this->_get['NewPassword'], base64_encode($this->_get['NewPassword']));

		// write new apiusers.conf
		$apiUsersNew = $adminLine . "\n" . 'provisioning:' . $newPasswordEnc . "\n";
		file_put_contents('/usr/conf/apiusers.conf', $apiUsersNew);

		return($this->_execResult);
	}

	function display () {
		return($this->_name . ':' . ($this->_execResult ? 'success' : $this->_execResultString));
	}
}

?>
